function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { IconFont } from '@zgfe/business-lib';
import { Button, Table } from 'antd';
import _ from 'lodash';
import React, { useEffect, useState } from 'react';
import ColumnName from './columnName';
import MappingInput from './mappingInput';
import { classPrefix } from './row2Column';
var AddList = function AddList(props) {
  var _useState = useState([]),
    _useState2 = _slicedToArray(_useState, 2),
    list = _useState2[0],
    setList = _useState2[1];
  useEffect(function () {
    var _ref;
    var res = (_ref = props.defaultValue || []) === null || _ref === void 0 ? void 0 : _ref.map(function (value) {
      return {
        key: Math.random(),
        value: /::/.test(value) ? value.split('::')[0] : value,
        mapping: /::/.test(value) ? value.split('::')[1] : ''
      };
    });
    setList(res.length ? res : [{
      key: Math.random(),
      value: ''
    }]);
  }, []);
  useEffect(function () {
    if (props.onChange) props.onChange(list.filter(function (item) {
      return item.value;
    }).map(function (item) {
      return "".concat(item.value, "::").concat(item.mapping);
    }));
  }, [list]);
  function onAdd() {
    setList(function (pre) {
      return [].concat(_toConsumableArray(pre), [{
        key: Math.random(),
        value: '',
        mapping: ''
      }]);
    });
  }
  function _onChange(value, record) {
    setList(function (pre) {
      var res = _.cloneDeep(pre);
      res.forEach(function (item) {
        if (item.key === record.key) {
          item.value = value;
        }
      });
      return res;
    });
  }
  function onChangeMapping(value, record) {
    setList(function (pre) {
      var res = _.cloneDeep(pre);
      res.forEach(function (item) {
        if (item.key === record.key) {
          item.mapping = value;
        }
      });
      return res;
    });
  }
  function onDel(record) {
    setList(function (pre) {
      var res = _.cloneDeep(pre);
      return res.filter(function (item) {
        return item.key !== record.key;
      });
    });
  }
  return /*#__PURE__*/React.createElement(Table, {
    columns: [{
      title: '列名',
      dataIndex: 'value',
      render: function render(value, record) {
        return /*#__PURE__*/React.createElement("div", {
          className: "".concat(classPrefix, "-edit-row")
        }, /*#__PURE__*/React.createElement(ColumnName, {
          defaultValue: value,
          onChange: function onChange(name) {
            _onChange(name, record);
          }
        }));
      }
    }, {
      title: /*#__PURE__*/React.createElement(React.Fragment, null, "\u6620\u5C04\u503C", /*#__PURE__*/React.createElement(Button, {
        type: "link",
        onClick: onAdd,
        disabled: list.length >= 7
      }, "\u6DFB\u52A0")),
      dataIndex: 'mapping',
      render: function render(val, record) {
        return /*#__PURE__*/React.createElement("div", {
          className: "".concat(classPrefix, "-edit-row")
        }, /*#__PURE__*/React.createElement(MappingInput, {
          defaultValue: val,
          onChange: function onChange(v) {
            onChangeMapping(v, record);
          }
        }), /*#__PURE__*/React.createElement(IconFont, {
          type: "shanchu1",
          className: list.length > 1 ? '' : 'disabled',
          onClick: function onClick() {
            if (list.length <= 1) return;
            onDel(record);
          }
        }));
      }
    }],
    pagination: false,
    dataSource: list,
    rowKey: "key"
  });
};
export default AddList;